;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;              blink                ;
;        timer, porta a bit         ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CSEG AT 0H 

;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;
main:
CALL waitonesec
CALL blinkclr

CALL waitonesec
CALL blinkset

JMP main

;;;;;;;;;;;;; blink ;;;;;;;;;;;;;;
blinkset:
MOV P1, #0H
RET

blinkclr:
MOV P1, #1H
RET

;;;;;;;;;;;;; wait ;;;;;;;;;;;;;;
; 12 000 000 Hz / 12 clock
; 1 000 000 / 100 cicli
; 10 000 (D8EF) = 256*216 (D8) + 239 (EF)
waitonesec:
MOV R5, #100 ; ripeto 100 volte
restart:

MOV TH0, #216
MOV TL0, #239
MOV TMOD, #01
SETB TR0 ; go!

JNB TF0, $ ; aspetto l'overflow
CLR TR0
DJNZ R5, restart 

RET

END
