;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     multiple of input number      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CSEG AT 0H 

;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;
; seriale
ORL TMOD, #20H
SETB TR1
MOV SCON, #50H
MOV TH1, #230 ; 2400 baud
ORL PCON, #80H

SETB TI

inizio:
MOV DPTR, #input
CALL puts

CALL getnumber ; in r3 mette il numero

MOV R1, #0 ; contatore

MOV R7, #29 ; n cicli, per evitare overflow oltre 255
; (28 * 9 = 252 !)

main:
MOV DPTR, #acapo
CALL puts

MOV A, R1
CALL putnumber

MOV DPTR, #per
CALL puts

MOV A, R3
CALL putonenumber

MOV DPTR, #uguale
CALL puts

MOV A, R3
MOV B, R1
MUL AB

CALL putnumber

INC R1

DJNZ R7, main

MOV DPTR, #acapo
CALL puts

JMP inizio

;;;;;;;;;;;; output str ;;;;;;;;;;;;;
putc:
JNB TI, putc
CLR TI
MOV SBUF, A
RET

puts:
CLR A
MOVC A, @A+DPTR
JNZ more
RET

more:
CALL putc
INC DPTR
JMP puts

;;;;;;;;;; output numeri ;;;;;;;;;;;
; stampa ok fino a 999, poi sborda sulla tabella ascii
putnumber:
JNB TI, putnumber
CLR TI

MOV B, #100 ; A numero da printare
DIV AB ; A quoziente, B resto

ADD A, #'0'
MOV SBUF, A

MOV A, B ; il resto diventa il dividendo della prossima div

JNB TI, $
CLR TI

MOV B, #10
DIV AB

ADD A, #'0'
MOV SBUF, A

JNB TI, $
CLR TI

MOV A, B
ADD A, #'0'
MOV SBUF, A

RET

putonenumber:
JNB TI, putonenumber
CLR TI

ADD A, #'0'
MOV SBUF, A

RET

;;;;;;;;;;;;; input ;;;;;;;;;;;;;;;;
getnumber:
JNB RI, getnumber ; aspetto
MOV A, sbuf ; leggo
clr ri ; pulisce il flag
call putc ; l'echo

SUBB A, #'0' ; e' un numero
MOV R3, A

RET

;;;;;;;;;;; code data ;;;;;;;;;;;;;
CR EQU 0DH
LF EQU 0AH

input: DB 'number: ', 0
per: DB ' * ', 0
uguale: DB ' = ', 0
acapo: DB CR, LF, 0

END

