;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;           name           ;
; in e out su seriale, stringhe, memoria esterna
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CSEG AT 0H

JMP start

; ____________________________________
putc:
JNB TI, putc
CLR TI
MOV SBUF, A
RET

puts:
CLR A
MOVC A, @A+DPTR
JNZ more
RET

more:
CALL putc
INC DPTR
JMP puts

; ____________________________________
putrs:
MOVX A, @DPTR
JNZ morer
RET

morer:
CALL putc
INC DPTR
JMP putrs

; ____________________________________
gets:
jnb ri, gets ; aspetto
MOV A, SBUF ; legge il carattere
CLR RI	; pulisce il flag
call putc ; l'echo
cjne a, #CR, NoCr ; Controla se CR

sjmp finegets  ; fine ...

NoCr:
MOVX @DPTR, A ; mette il carattere nel buffer
INC DPTR
djnz R1, gets ; continua fino a fine buffer
finegets:

MOV A, #0
MOVX @DPTR, A
RET

; ____________________________________
start:
; inizializzo la seriale
ORL TMOD, #20H
SETB TR1
MOV SCON, #50H
MOV TH1, #230
ORL PCON, #80H

SETB TI

MOV DPTR, #question
CALL puts

MOV DPTR, #inbuff
MOV R1, #inlen
CALL gets

MOV DPTR, #answer1
CALL puts

MOV DPTR, #inbuff
CALL putrs 

MOV DPTR, #answer2
CALL puts

JMP $

; ____________________________________
; testo
inbuff EQU 0 
inlen EQU 10

CR EQU 0DH
LF EQU 0AH

question: 
DB 'What is your name? ', 0
answer1: 
DB CR, LF, 'Hi ', 0
answer2: 
DB ' !', CR, LF, 0

END

